// (C) Bad HAL 9000 [ Pat Bigler ] Dec 2006
// http://specialed.gamedeception.net
// If you use this please credit myself, Nullsoft, and Game-Deception


#include <windows.h>
#include <stdio.h>
#include "WinAmp_Interface.h"

#include "wa_ipc.h"


CWinAmp winamp;


bool CWinAmp::InitWinamp(){

	if(!hwndWinAmp)
		hwndWinAmp = FindWindow("Winamp v1.x", NULL);

	if(hwndWinAmp){
		GetWindowThreadProcessId(hwndWinAmp, &dwProcId);
		hProc = OpenProcess(PROCESS_VM_READ, FALSE, dwProcId);
		return true;

	}	
	return false;
}

bool CWinAmp::StartWinAmp(){
//TODO: Find a new method, reg does not seem reliable with Vista
	DWORD cSize;
	char szPath[MAX_PATH+1];
	HKEY hKey;
	// Open key to find path of application
	LONG lRet = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\explorer\\AutoplayHandlers\\Handlers\\WinampMTPHandler", 0, KEY_QUERY_VALUE, &hKey);
	if (lRet != ERROR_SUCCESS) 
	{
		return false;
	}
	// Query value of key to get Path and close the key
	lRet = RegQueryValueEx(hKey, "InitCmdLine", NULL, NULL, (BYTE*)szPath, &cSize);
	RegCloseKey(hKey);
	if (lRet != ERROR_SUCCESS)
	{
		return false;
	}
	ShellExecute(NULL, "open", szPath, NULL, NULL, SW_MINIMIZE);

	return true;

}

bool CWinAmp::LocateWinAmp(char *out)
{
	DWORD cSize;
	char szPath[MAX_PATH+1];
	HKEY hKey;
	// Open key to find path of application
	LONG lRet = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Clients\\Media\\Winamp\\shell\\open\\command", 0, KEY_QUERY_VALUE, &hKey);
	if (lRet != ERROR_SUCCESS) 
	{
		return false;
	}
	// Query value of key to get Path and close the key
	lRet = RegQueryValueEx(hKey, NULL, NULL, NULL, (BYTE*)szPath, &cSize);
	RegCloseKey(hKey);
	if (lRet != ERROR_SUCCESS)
	{
		return false;
	}

	strcpy(out, szPath);
		return true;
}

void CWinAmp::GetCurrentTrack(char *out){
	char szBuffer[512] = "";
	if(hwndWinAmp)
	{
	int TrackPos = (int)SendMessage(hwndWinAmp, WM_WA_IPC, 0, IPC_GETLISTPOS);
	ReadProcessMemory(hProc, (char*)SendMessage(hwndWinAmp, WM_WA_IPC, TrackPos, IPC_GETPLAYLISTTITLE), szBuffer, sizeof(szBuffer), &dwBytes);
	strncpy(out, szBuffer, sizeof(szBuffer));
	}

}

void CWinAmp::GetNextTrack(char *out){
	char szBuffer[512] = "";
	if(hwndWinAmp)
	{
	int TrackPos = (int)SendMessage(hwndWinAmp, WM_WA_IPC, 0, IPC_GETLISTPOS) + 1;
	ReadProcessMemory(hProc, (char*)SendMessage(hwndWinAmp, WM_WA_IPC, TrackPos, IPC_GETPLAYLISTTITLE), szBuffer, sizeof(szBuffer), &dwBytes);
	strncpy(out, szBuffer, sizeof(szBuffer));
	}
}

void CWinAmp::GetTrackByIndex(int index, char *out){
	char szBuffer[512] = "";
	if(hwndWinAmp)
	{
	ReadProcessMemory(hProc,(char*)SendMessage(hwndWinAmp, WM_WA_IPC, index, IPC_GETPLAYLISTTITLE), szBuffer, sizeof(szBuffer), &dwBytes);
	strncpy(out, szBuffer, sizeof(szBuffer));
	}
}

void CWinAmp::GetChannels(char *out){
	if(hwndWinAmp)
	{
		int channels = (int)SendMessage(hwndWinAmp, WM_WA_IPC, 2, IPC_GETINFO);
		if( channels == 1 ){
			strcpy(out, "Mono");
		} else if( channels == 2 ){
			strcpy(out, "Stereo");
		} else {
			strcpy(out, "Unknown");
		}
	}

}

int CWinAmp::GetSamplerate( ){
	if(hwndWinAmp)
	{
		return (int)SendMessage(hwndWinAmp, WM_WA_IPC, 0, IPC_GETINFO);;
	}
	return NULL;
}

int CWinAmp::GetBitrate( ){
	if(hwndWinAmp)
	{
		return (int)SendMessage(hwndWinAmp, WM_WA_IPC, 1, IPC_GETINFO);;
	}
	return NULL;
}

int CWinAmp::GetSongPos( ){
	if(hwndWinAmp)
	{
		return (int)SendMessage(hwndWinAmp, WM_WA_IPC, 0, IPC_GETOUTPUTTIME);
	}
	return NULL;
}

int CWinAmp::GetSongLen( ){
	if(hwndWinAmp)
	{
		return (int)SendMessage(hwndWinAmp, WM_WA_IPC, 1, IPC_GETOUTPUTTIME);
	}
	return NULL;

}

// This returns the song length in a nifty little reformatted "Min:Sec" format
void CWinAmp::GetSongLenS(char *out){
	if(hwndWinAmp)
	{
		int minutes = (GetSongLen() / 60) % 60;
		int seconds = (GetSongLen() ) % 60;
		sprintf(out, "%02i:%02i", minutes, seconds);
	}

}

void CWinAmp::GetSongPosS(char *out){
	if(hwndWinAmp)
	{
		int minutes = (GetSongPos() / 1000 / 60 )  % 60;
		int seconds = (GetSongPos() / 1000 ) % 60;
		sprintf(out, "%02i:%02i", minutes, seconds);
	}

}

int CWinAmp::TrackPercent(){

	if(hwndWinAmp)
	{

	int iTmp1 = (int)SendMessage(hwndWinAmp,WM_WA_IPC,1,IPC_GETOUTPUTTIME);
	int iTmp2 = (int)SendMessage(hwndWinAmp,WM_WA_IPC,0,IPC_GETOUTPUTTIME) / 10;


	return iTmp2 / iTmp1;
	}
	return NULL;
}


int CWinAmp::CurrentPlayMode()
{
	if(hwndWinAmp)
		return (int)SendMessage(hwndWinAmp,WM_WA_IPC,0,IPC_ISPLAYING);
	else
		return 0;
}

int CWinAmp::GetPlaylistLen()
{
	if(hwndWinAmp)
		return (int)SendMessage(hwndWinAmp,WM_WA_IPC,0,IPC_GETLISTLENGTH);
	else
		return 0;
}

int CWinAmp::GetPlaylistPos()
{
	if(hwndWinAmp)
		return (int)SendMessage(hwndWinAmp,WM_WA_IPC,0,IPC_GETLISTPOS);
	else
		return 0;
}

void CWinAmp::SetPlaylistPos(int index)
{
	if(hwndWinAmp)
		SendMessage(hwndWinAmp,WM_WA_IPC,index,IPC_SETPLAYLISTPOS);
}


int CWinAmp::GetEQData(int slot)
{
	if(hwndWinAmp)
	{
		return (int)SendMessage(hwndWinAmp,WM_WA_IPC,slot,IPC_GETEQDATA);
	}
	else
		return 0;
}


int CWinAmp::GetEQMode()
{

	if(hwndWinAmp)
		return (int)SendMessage(hwndWinAmp, WM_WA_IPC, 11, IPC_GETEQDATA);
	else
		return false;
}

int CWinAmp::GetEQAutoMode()
{
	if(hwndWinAmp)
		return (int)SendMessage(hwndWinAmp, WM_WA_IPC, 12, IPC_GETEQDATA);
	else 
		return 0;
}

int CWinAmp::GetPan()
{
	if(hwndWinAmp)
		return (int)SendMessage(hwndWinAmp,WM_WA_IPC,-666,IPC_SETPANNING);
	else 
		return 0;
}


void CWinAmp::Stop(){
	if(hwndWinAmp)
		SendMessage(hwndWinAmp, WM_COMMAND, WINAMP_BUTTON4, 0);
}

void CWinAmp::Pause(){
	if(hwndWinAmp)
		SendMessage(hwndWinAmp, WM_COMMAND, WINAMP_BUTTON3, 0);
}

void CWinAmp::Play(){
	if(hwndWinAmp)
		SendMessage(hwndWinAmp, WM_COMMAND, WINAMP_BUTTON2, 0);
}

void CWinAmp::Next(){
	if(hwndWinAmp)
		SendMessage(hwndWinAmp, WM_COMMAND, WINAMP_BUTTON5, 0);

}

void CWinAmp::Previous(){
	if(hwndWinAmp)
		SendMessage(hwndWinAmp, WM_COMMAND, WINAMP_BUTTON1, 0);

}

int CWinAmp::SeekToTime(int ms){
	if(hwndWinAmp)
		return (int)SendMessage(hwndWinAmp, WM_WA_IPC, ms, IPC_JUMPTOTIME);
	else
		return	1;

}

void CWinAmp::SetPlaylistIndex(int track)
{
	if(hwndWinAmp)
		SendMessage(hwndWinAmp,WM_WA_IPC,track,IPC_SETPLAYLISTPOS);

}

int CWinAmp::GetRepeatMode()
{
	if(hwndWinAmp)
		return (int)SendMessage(hwndWinAmp,WM_WA_IPC,0,IPC_GET_REPEAT);
	else
		return 0;
}

int CWinAmp::GetShuffleMode()
{
	if(hwndWinAmp)
		return (int)SendMessage(hwndWinAmp,WM_WA_IPC,0,IPC_GET_SHUFFLE);
	else
		return 0;
}

void CWinAmp::EnqueFile(char *filename)
{

	COPYDATASTRUCT cds;
	cds.dwData = IPC_PLAYFILE;
	cds.cbData = lstrlen(filename) + 1;
	cds.lpData = (void *) filename;
	SendMessage(hwndWinAmp, WM_COPYDATA, (WPARAM)NULL, (LPARAM)&cds);
/*

	COPYDATASTRUCT cds;
	cds.dwData = IPC_PLAYFILE;
	cds.lpData = filename; //variable which holds a pointer to songfilename
	cds.cwData = strlen(filename);
	HWND hwndWinAmp = FindWindow("Winamp v1.x", NULL);
	if (IsWindow(hwndWinAmp)) {
		int result = SendMessage(hwnd_winamp, WM_COPYDATA, (WPARAM)hwnd_mediamonkey, (LPARAM)&cds);
	} 
	*/
}

void CWinAmp::SetVolume(int vol)
{
	if(hwndWinAmp)
	{
		SendMessage(hwndWinAmp,WM_WA_IPC,vol,IPC_SETVOLUME);
	}
}

int CWinAmp::GetVolume()
{
	if(hwndWinAmp)
		return (int)SendMessage(hwndWinAmp,WM_WA_IPC,-666, IPC_SETVOLUME);
	else
		return 0;
}

void CWinAmp::SetRepeatMode(int status)
{
	if(hwndWinAmp)
		SendMessage(hwndWinAmp,WM_WA_IPC,status,IPC_SET_REPEAT);
}

void CWinAmp::SetShuffleMode(int status)
{
	if(hwndWinAmp)
		SendMessage(hwndWinAmp,WM_WA_IPC,status,IPC_SET_SHUFFLE);

}

void CWinAmp::SetEQData(int slot, int value)
{
	if(hwndWinAmp)
	{
		SendMessage(hwndWinAmp,WM_WA_IPC,slot,IPC_GETEQDATA);
		SendMessage(hwndWinAmp,WM_WA_IPC,value,IPC_SETEQDATA);
	}
}

void CWinAmp::SetPan(int pan)
{
	if(hwndWinAmp)
		SendMessage(hwndWinAmp,WM_WA_IPC,pan,IPC_SETPANNING);
}

void CWinAmp::SetEQMode(int state)
{
	if(hwndWinAmp)
	{
		SendMessage(hwndWinAmp,WM_WA_IPC,11,IPC_GETEQDATA);
		SendMessage(hwndWinAmp,WM_WA_IPC,state,IPC_SETEQDATA);
	}
}

void CWinAmp::SetEQAutoMode(int state)
{
	if(hwndWinAmp)
	{
		SendMessage(hwndWinAmp,WM_WA_IPC,12,IPC_GETEQDATA);
		SendMessage(hwndWinAmp,WM_WA_IPC,state,IPC_SETEQDATA);
	}
}
/*
int CWinAmp::WritePlaylist()
{

	if(hwndWinAmp)
	{
	
		//char m3uDir[MAX_PATH] = "C:\\Program Files\\WinAmp\\Winamp.m3u";
		char m3uDir[MAX_PATH] = "";

		char szTempx1[MAX_PATH] = "";
		char szTempx2[MAX_PATH] = "";
		
		//GetModuleFileName(modhandle,szTemp2,MAX_PATH);
		if( !LocateWinAmp(szTempx2) )
			return 0;

		char *pszTemp = strrchr(szTempx2,'\\');	// This is the actual filename "yourhack.dll"
		memmove(szTempx1,szTempx2,pszTemp-szTempx2+1);
		strncat(szTempx1,"Winamp.m3u",strlen("Winamp.m3u"));
		strcpy(m3uDir, szTempx1);



		int iRet = (int)SendMessage(hwndWinAmp,WM_WA_IPC,0,IPC_WRITEPLAYLIST);
		Sleep(10);
		// Clear the vector! OH NOEZ
		plPlaylist.clear();


		// Parse the file

		FILE *file;

	file = fopen(m3uDir, "r");

	if(file == NULL){
		printf("Error opening M3U file, does it exist?\n");
		return 0; }

	// Fill the a temp buffer up with the contents of a single line
	char szBuffer[1024] = "";

	// Some temp buffers
	char *szTemp1;
	char *szTemp2;

	int iIndex = 0;
	while( fgets(szBuffer, 1024, file) )
	{
		
		// Only grab lines that have the cool text and time
	if(szBuffer[0] == '#' && szBuffer[1] == 'E' && szBuffer[2] == 'X' && szBuffer[3] == 'T' &&
		szBuffer[4] == 'I' && szBuffer[5] == 'N' && szBuffer[6] == 'F' && szBuffer[7] == ':')
	{
		iIndex++;
		// Create a new playlist entry
		playlist_entry_s new_entry;

		// Need to find the track name somehow eh?
		szTemp1 = strchr(szBuffer, ',')+1;
		// Gay! there is a \newline character at the end of it that wont strip off. HACKY!
		strncpy(new_entry.szTrackName, szTemp1, strlen(szTemp1));
		new_entry.szTrackName[strlen(szTemp1)-1] = '\0';


		// Now grab everything after the time				
		szTemp2 = strchr(szBuffer, ':')+1;		
		char szTime[256];
		// Remove the trailing string (which is the track name and crap)
		memmove(szTime,szTemp2,szTemp1-szTemp2);
		// Convert and stick in the playlist entry
		new_entry.iTrackTime = atoi(szTime);


		// Done! Throw the new entry in the playlist
		plPlaylist.push_back(new_entry);



		}

	}

	
	// Done! close the file
	fclose(file);
	



		return iRet;
	}
	else return 0;
}

void CWinAmp::ReadPLTRName(int index, char *out)
{
	if(plPlaylist.empty())
		strcpy(out, "(ERROR)");

	strcpy(out, plPlaylist[index].szTrackName);
}

int CWinAmp::ReadPLTRLength(int index)
{
	if(plPlaylist.empty())
		return 0;

	return plPlaylist[index].iTrackTime;
}

void CWinAmp::ReadPLTRLengthS(int index, char *out)
{
	if(plPlaylist.empty())
		strcpy(out, "(ERROR)");

	int minutes = (plPlaylist[index].iTrackTime / 60) % 60;
	int seconds = (plPlaylist[index].iTrackTime ) % 60;
	sprintf(out, "%02i:%02i", minutes, seconds);

}
*/