// (C) Bad HAL 9000 [ Pat Bigler ] Dec 2006
// If you use this please credit myself, Nullsoft, and Game-Deception
//

// Blar!
#include <vector>

using namespace std;

struct playlist_entry_s {
	char szTrackName[256];
	int iTrackTime;
};

class CWinAmp {
public:

	// Setup the interface between the module and WinAmp
	bool InitWinamp( );
	
	// Locate and start WinAmp
	bool StartWinAmp();
	// Just spits out the location of WinAmp (not needed for above)
	bool LocateWinAmp(char *out);

	// Get the track name
	void GetCurrentTrack(char *out);
	// Get the next track's name
	void GetNextTrack(char *out);
	// Get a track name by play list index
	void GetTrackByIndex(int index, char *out);
	// Get the track's bitrate (EG: 120 kbps)
	int GetBitrate( );
	// Get the sample rate (EG: 44 khz");
	int GetSamplerate( );
	// Get the songs channels (Stereo, mono, etc)
	void GetChannels(char *out);
	// Get the current track's playing position in milliseconds
	int GetSongPos( );
	// Get the current track's total length of song in seconds
	int GetSongLen( );
	// Get the current track's total length of song in a nice little formated MIN:SEC
	void GetSongLenS(char *out);
	// Get the current track's playing position in a nice little formated MIN:SEC
	void GetSongPosS(char *out);
	// Get the percentage of how much of the track is completed playing (Useful for progress bars and such)
	int TrackPercent( );
	// Get the volume amount (%age)
	int GetVolume( );

	// Is the song currently playing? 1 = playing, 3 = paused, 0 = stopped 
	int CurrentPlayMode( );
	
	// How long is our playlist?
	int GetPlaylistLen( );
	// Where are we in the playlist?
	int GetPlaylistPos( );
	// Set our index in the playlist.
	void SetPlaylistPos(int index);

	// Get our repeat mode (t=on;f=off)
	int GetRepeatMode( );
	// Get our shuffle mode (t=on;f=off)
	int GetShuffleMode( );

	void EnqueFile(char *filename);

	// Control winamp!
	void Stop( );
	void Pause( );
	void Play( );
	void Next( );
	void Previous( );
	int SeekToTime(int ms);
	void SetPlaylistIndex(int track);
	void SetVolume(int vol);
	// Set our repeat mode (t=on;f=off)
	void SetRepeatMode(int status);
	// Set our shuffle mode (t=on;f=off)
	void SetShuffleMode(int status);
	

	// EQ Data
	int GetEQData(int slot);
	void SetEQData(int slot, int value);
	int GetEQMode( ); // On or off?
	void SetEQMode(int state); // On or off?
	int GetEQAutoMode( ); // On or off?
	void SetEQAutoMode(int state); // On or off?

	// Panning
	int GetPan();
	void SetPan(int pan); // 0 left; 255 right


	// Playlist management - also returns the current place in playlist
	int WritePlaylist();
	// Reads the track's name from the playlist based on the specified index
	void ReadPLTRName(int index, char *out);
	// Reads the track's total length based on the specified index
	int ReadPLTRLength(int index);
	// Reads the track's total length based on index, outputs in pretty MM:SS format
	void ReadPLTRLengthS(int index, char *out);


private:
	HWND hwndWinAmp;
	DWORD dwProcId;
	DWORD dwBytes;
	HANDLE hProc;

	vector<playlist_entry_s> plPlaylist;

};

extern CWinAmp winamp;