//=============================================================================//
//  ___  ___   _   _   _    __   _   ___ ___ __ __
// |_ _|| __| / \ | \_/ |  / _| / \ | o \ o \\ V /
//  | | | _| | o || \_/ | ( |_n| o ||   /   / \ / 
//  |_| |___||_n_||_| |_|  \__/|_n_||_|\\_|\\ |_|  2006
//										 
// And more importantly, Bad HAL 9000 [ Pat Bigler ] Dec 2006
//=============================================================================//

#include <windows.h>
#include "common/GMLuaModule.h"
#include "WinAmp_Interface.h"

// This is a macro to make life easier.
// When the dll is loaded it will call the function (Init)
GMOD_MODULE( Init, Shutdown );


// Use this to initialize winamp, this MUST be called for anything else to work
LUA_FUNCTION( lSetupWinAmp )
{
	bool bRet = winamp.InitWinamp();
	g_Lua->Push( bRet );
	return 1;
}

// This actually launches WinAmp, fun
LUA_FUNCTION( lStartWinAmp )
{
	bool bRet = winamp.StartWinAmp();
	g_Lua->Push(bRet);
	return 1;
}
/*
// Write the WinAmp playlist to disk to enable the ability to read it faster, also returns current pos
LUA_FUNCTION( lWritePlaylist )
{
	int bRet = winamp.WritePlaylist();
	g_Lua->Push(float(bRet));
	return 1;
}

// Read the data from the playlist (must have been written) 
LUA_FUNCTION( lReadPLTRName )
{
	char szBuffer[512] = "";
	int iIndex = g_Lua->GetInteger(1);
	winamp.ReadPLTRName(iIndex, szBuffer);

	g_Lua->Push(szBuffer);

	return 1;

}

LUA_FUNCTION( lReadPLTRLength )
{
	int iIndex = g_Lua->GetInteger(1);
	int iRet = winamp.ReadPLTRLength(iIndex);

	g_Lua->Push(float(iRet));

	return 1;
}

LUA_FUNCTION( lReadPLTRLengthS )
{
	char szBuffer[128] = "";
	int iIndex = g_Lua->GetInteger(1);
	winamp.ReadPLTRLengthS(iIndex, szBuffer);

	g_Lua->Push(szBuffer);

	return 1;
}
*/
// Get the current track (string)
LUA_FUNCTION( lGetCurrentTrack )
{
	char szBuffer[512] = "";
	winamp.GetCurrentTrack(szBuffer);
	
	g_Lua->Push(szBuffer);

	return 1;
}

// Get the next track on the play list (string)
LUA_FUNCTION( lGetNextTrack )
{
	char szBuffer[512] = "";
	winamp.GetNextTrack(szBuffer);
	
	g_Lua->Push(szBuffer);

	return 1;
}

// Gets the track name by index, on your play list (string)
LUA_FUNCTION( lGetTrackByIndex )
{
	char szBuffer[512] = "";
	int iIndex = g_Lua->GetInteger(1);
	winamp.GetTrackByIndex(iIndex, szBuffer);

	g_Lua->Push(szBuffer);

	return 1;
}

// Get the bitrate of the currently playing song (EG: 120 kbps)
LUA_FUNCTION( lGetBitrate )
{
	g_Lua->Push( (float)winamp.GetBitrate() );
	
	return 1;
}

// Get the sample rate of the currently playing song (EG: 44 khz");
LUA_FUNCTION( lGetSamplerate )
{
	g_Lua->Push( (float)winamp.GetSamplerate() );

	return 1;
}

// Get the channel information of the currently playing song (string: "Mono", "Stero", etc )
LUA_FUNCTION( lGetChannels )
{
	char szBuffer[24] = "";
	winamp.GetChannels(szBuffer);

	g_Lua->Push( szBuffer );

	return 1;
}

// Get the current track's playing position in milliseconds
LUA_FUNCTION( lGetSongPos )
{
	g_Lua->Push( (float)winamp.GetSongPos() );

	return 1;
}

// Get the current track's total length of song in seconds
LUA_FUNCTION( lGetSongLen )
{
	g_Lua->Push( (float)winamp.GetSongLen() );

	return 1;
}

// Get the current track's total length of song in a nice little formated MIN:SEC
LUA_FUNCTION( lGetSongLenS )
{
	char szBuffer[64] = "";
	winamp.GetSongLenS( szBuffer );

	g_Lua->Push( szBuffer );

	return 1;
}

// Get the current track's playing position in a nice little formated MIN:SEC
LUA_FUNCTION( lGetSongPosS )
{
	char szBuffer[64] = "";
	winamp.GetSongPosS( szBuffer );

	g_Lua->Push( szBuffer );

	return 1;
}


// Is the song playing? (1 = playing, 3 = paused, 0 = stopped)
LUA_FUNCTION( lCurrentPlayMode )
{
	int iRet = winamp.CurrentPlayMode();

	g_Lua->Push((float)iRet);

	return 1;
}

// How many tracks are in our current playlist?
LUA_FUNCTION( lGetPlaylistLen )
{
	int iRet = winamp.GetPlaylistLen();

	g_Lua->Push((float)iRet);

	return 1;
}

// What is the index of the currently playing song in the playlist?
LUA_FUNCTION( lGetPlaylistPos )
{
	int iRet = winamp.GetPlaylistPos();

	g_Lua->Push((float)iRet);

	return 1;
}

// What is the index of the currently playing song in the playlist?
LUA_FUNCTION( lSetPlaylistPos )
{

	int iIndex = g_Lua->GetInteger(1);
	winamp.SetPlaylistPos(iIndex);

	return 0;
}

// Get our current repeat mode (t=on;f=off)
LUA_FUNCTION( lGetRepeatMode )
{
	int iRet = winamp.GetRepeatMode();

	g_Lua->Push((float)iRet);

	return 1;
}

// Get our current shuffle status
LUA_FUNCTION( lGetShuffleMode )
{
	int iRet = winamp.GetShuffleMode();

	g_Lua->Push((float)iRet);

	return 1;
}

// Get the percentage of how much of the track is completed playing (Useful for progress bars and such)
LUA_FUNCTION( lTrackPercent )
{
	g_Lua->Push( (float)winamp.TrackPercent() );

	return 1;
}

LUA_FUNCTION( lEnqueFile )
{
	winamp.EnqueFile(const_cast<char*>(g_Lua->GetString(1)));

	return 0;
}

// Control WinAmp
// Stop, duh
LUA_FUNCTION( lStop )
{
	winamp.Stop();

	return 0;
}

// Pause, duh
LUA_FUNCTION( lPause )
{
	winamp.Pause();

	return 0;
}

// Play, duh
LUA_FUNCTION( lPlay )
{
	winamp.Play();

	return 0;
}

// Next, duh
LUA_FUNCTION( lNext )
{
	winamp.Next();

	return 0;
}

// Previous, duh
LUA_FUNCTION( lPrevious )
{
	winamp.Previous();

	return 0;
}

// Sets the volume of winamp's output (0-255)
LUA_FUNCTION( lSetVolume )
{
	int iVolume = g_Lua->GetInteger(1);
	winamp.SetVolume(iVolume);

	return 0;
}

// Retrieve the current volume (0-255)
LUA_FUNCTION( lGetVolume )
{
	int iRet = winamp.GetVolume();
	
	g_Lua->Push((float)iRet);

	return 1;
}

// Seeks to the specified time in the current track. Yay!
// Returns -1 if not playing, 1 on eof, or 0 if successful
LUA_FUNCTION( lSeekToTime )
{
	int iMS = g_Lua->GetInteger(1);
	int iRet = winamp.SeekToTime(iMS);

	// Returns a few different types of errors :(
	g_Lua->Push((float)iRet);
	

	return 1;
}

// Set the currently playing song to the specified index in your playlist
LUA_FUNCTION( lSetPlaylistIndex )
{
	int iIndex = g_Lua->GetInteger(1);

	winamp.SetPlaylistIndex(iIndex);

	return 0;
}

// Set the repeat mode (t=on;f=off)
LUA_FUNCTION( lSetRepeatMode )
{
	int iMode = g_Lua->GetInteger(1);

	winamp.SetRepeatMode(iMode);

	return 0;
}

// Set the shuffle mode (0=off;1=playlistrepeat;2=songrepeat)
LUA_FUNCTION( lSetShuffleMode )
{
	int iMode = g_Lua->GetInteger(1);

	winamp.SetShuffleMode(iMode);

	return 0;
}


// EWWWWWWWW!
LUA_FUNCTION( lIsMouse1Down )
{
	if( GetAsyncKeyState( VK_LBUTTON ) & 0x8000 )
		g_Lua->Push(true);
	else 
		g_Lua->Push(false);
		
		return 1;

}

// EQ Functions
LUA_FUNCTION( lGetEQData )
{
	int iSlot = g_Lua->GetInteger(1);

	int iRet = winamp.GetEQData(iSlot);

	g_Lua->Push((float)iRet);

	return 1;

}



LUA_FUNCTION( lSetEQData )
{
	int iSlot = g_Lua->GetInteger(1);
	int iValue = g_Lua->GetInteger(2);

    winamp.SetEQData(iSlot, iValue);

	return 0;
}


LUA_FUNCTION( lGetEQMode )
{
	int iRet = winamp.GetEQMode();

	g_Lua->Push((float)iRet);

	return 1;

}


LUA_FUNCTION( lGetEQAutoMode )
{
	int iRet = winamp.GetEQAutoMode();

	g_Lua->Push((float)iRet);

	return 1;
}

LUA_FUNCTION( lGetPan )
{
	int iRet = winamp.GetPan();

	g_Lua->Push((float)iRet);

	return 1;
}

LUA_FUNCTION( lSetPan )
{
	int iPan = g_Lua->GetInteger(1);

	winamp.SetPan(iPan);

	return 0;

}


LUA_FUNCTION( lSetEQMode )
{
	int bState = g_Lua->GetInteger(1);

	winamp.SetEQMode(bState);

	return 0;
}

LUA_FUNCTION( lSetEQAutoMode )
{
	int bState = g_Lua->GetInteger(1);

	winamp.SetEQAutoMode(bState);

	return 0;
}
// When the DLL is initialized it will call this function to set itself up.
// It should be used to set up your library so it's all ready to go.
int Init( void )
{

	// Lets make a global table filled with functions (a module)
	g_Lua->NewGlobalTable( "winamp" );
	ILuaObject* table = g_Lua->GetGlobal( "winamp" );

		// Initialize winamp
		table->SetMember( "SetupWinAmp", lSetupWinAmp );

		table->SetMember( "StartWinAmp", lStartWinAmp );

		/* REMOVED, buggy and does not work with the new WinAmp
		// Playlist management
		table->SetMember( "WritePlaylist", lWritePlaylist );
		table->SetMember( "GetTrackNameFromFile", lReadPLTRName );
		table->SetMember( "GetTrackLengthFromFile", lReadPLTRLength );
		table->SetMember( "GetTrackLengthFromFileS", lReadPLTRLengthS );
		*/

		// Gather winamp information
		table->SetMember( "CurrentPlayMode", lCurrentPlayMode );
		table->SetMember( "GetCurrentTrack", lGetCurrentTrack );
		table->SetMember( "GetNextTrack", lGetNextTrack );
		table->SetMember( "GetTrackByIndex", lGetTrackByIndex );
		table->SetMember( "GetBitrate", lGetBitrate );
		table->SetMember( "GetSamplerate", lGetSamplerate );
		table->SetMember( "GetChannels", lGetChannels );
		table->SetMember( "GetSongPos", lGetSongPos );
		table->SetMember( "GetSongLen", lGetSongLen );
		table->SetMember( "GetSongLenS", lGetSongLenS );
		table->SetMember( "GetSongPosS", lGetSongPosS );
		table->SetMember( "GetVolume", lGetVolume );
		table->SetMember( "GetPlaylistLen", lGetPlaylistLen );
		table->SetMember( "GetPlaylistPos", lGetPlaylistPos );
		table->SetMember( "SetPlaylistPos", lSetPlaylistPos );
		table->SetMember( "GetRepeatMode", lGetRepeatMode );
		table->SetMember( "GetShuffleMode", lGetShuffleMode );
		table->SetMember( "TrackPercent", lTrackPercent );

		table->SetMember( "EnqueFile", lEnqueFile );

		// Control winamp!
		table->SetMember( "Stop", lStop );
		table->SetMember( "Pause", lPause );
		table->SetMember( "Play", lPlay );
		table->SetMember( "Next", lNext );
		table->SetMember( "Previous", lPrevious );
		table->SetMember( "SetVolume", lSetVolume );
		table->SetMember( "SeekToTime", lSeekToTime );
		table->SetMember( "SetPlaylistIndex", lSetPlaylistIndex );
		table->SetMember( "SetRepeatMode", lSetRepeatMode );
		table->SetMember( "SetShuffleMode", lSetShuffleMode );

		// EQ Data
		table->SetMember( "GetEQData", lGetEQData );
		table->SetMember( "SetEQData", lSetEQData );
		table->SetMember( "GetEQMode", lGetEQMode );
		table->SetMember( "SetEQMode", lSetEQMode );
		table->SetMember( "GetEQAutoMode", lGetEQAutoMode );
		table->SetMember( "SetEQAutoMode", lSetEQAutoMode );

		// Panning
		table->SetMember( "GetPan", lGetPan );
		table->SetMember( "SetPan", lSetPan );


		// This is a stupid compatibility function so I can detect if the mouse button is down! OMG!
		table->SetMember( "IsMouse1Down", lIsMouse1Down );
	// We're not deleting the table here - we're deleting the reference to it.
	// If you don't do this you're leaking memory.
	SAFE_UNREF( table );

	return 0;
}

// When the DLL is shutdown it calls this function.
// g_Lua should be assumed to have been released here
int Shutdown( void )
{
	
	return 0;
}