
require( "WinAmp_Interface" )

bDidInit = false
czCurrentSong = " "
iTrackPercent = 0
szCurTimePlayed = " "
szCurTotalTime = " "

include( "includes/WinAmp_MiscFeatures.lua" )
include( "includes/WinAmp_OptionsDialog.lua" )
include( "includes/WinAmp_EqualizerDialog.lua" )
include( "includes/WinAmp_HUD.lua" )


// Some little information holders
local iLastTrackID = 0
local iLastVol = 0

// This is the global player handle
local wndPlayer = nil

// Some global controls that we may need to access from somewhere else
local lblCurrentSong = nil
local lblTime = nil
local lblSampleRate = nil
local lblChannels = nil
local lblVolume = nil

// Check boxes
local chkRepeat = nil
local chkShuffle = nil
local cvShuf = CreateClientConVar( "winamp_shuffle", "0", false, false )
local cvRep = CreateClientConVar( "winamp_repeat", "0", false, false )

local plsPlayList = nil

// Sliders
local sldSeek = nil
local sldVolume = nil

function WinAmp_UpdateDialog()
// Only update if the controls are all valid
if(wndPlayer != nil) then
szCurrentSong = winamp.GetCurrentTrack()
iTrackPercent = winamp.TrackPercent()
szCurTimePlayed = winamp.GetSongPosS()
szCurTotalTime = winamp.GetSongLenS()

if(wndEqualizer != nil) then
if(wndEqualizer:IsVisible()) then
	winamp.SetEQMode(cvEQOn:GetInt())
	winamp.SetEQAutoMode(cvEQAuto:GetInt())
end
end
// Another check
if(wndPlayer:IsVisible()) then
	
	local icurpos = winamp.GetPlaylistPos()
	if( icurpos != iLastTrackID ) then
		// Set the new song playing :)
		plsPlayList:ClearSelection()
		plsPlayList:SelectItem( plsPlayList:GetLine(icurpos+1) )		
		iLastTrackID = icurpos
		// Scroll to the song (if possible)
		plsPlayList.VBar:SetScroll(icurpos*17)
	end
	
	// Current song
	
	lblCurrentSong:SetText( szCurrentSong )
	
	lblTime:SetText( szCurTimePlayed .. " / " .. szCurTotalTime )
	lblSampleRate:SetText( winamp.GetBitrate() .. " kbps | " .. winamp.GetSamplerate() .. " khz" )
	lblChannels:SetText( winamp.GetChannels() )
	local iVol = winamp.GetVolume()
	iLastVol = iVol
	if( iVol != 0 ) then
		lblVolume:SetText( "Volume: " .. math.ceil(iVol / 2.55) .. "%" )
	else
		lblVolume:SetText( "Muted" )
	end
	
	winamp.SetRepeatMode(cvRep:GetInt())
	winamp.SetShuffleMode(cvShuf:GetInt())
	
	sldSeek:PostMessage( "SetValue", "f", winamp.GetSongPos() * 0.001)
	sldSeek:PostMessage( "SetHigher", "f", winamp.GetSongLen() )
	
	sldVolume:PostMessage( "SetValue", "f", iVol )

end
end
end

// Volume slider
local function afVolume( panel, message, param1, param2 )
	if ( ( message != "SliderMoved" ) ) then return end	
	if( MouseIsInBounds( sldVolume, 2 ) ) then
		winamp.SetVolume( param1 )
		lblVolume:SetText( "Volume: " .. math.ceil(param1 / 2.55) .. "%" )
	end
end

// Seek bar
local function afSeek( panel, message, param1, param2 )
	if ( ( message != "SliderMoved" ) ) then return end
	if( MouseIsInBounds( sldSeek, 2 ) ) then
		winamp.SeekToTime( param1 * 1000 )
	end
end


function WinAmp_UpdatePlaylist()
	plsPlayList:Clear()
	iPlaylistLen = winamp.GetPlaylistLen() - 1
	local iCurPos = winamp.GetPlaylistPos()
	for i = 0, iPlaylistLen, 1 do
		
		plsPlayList:AddLine(  i + 1, winamp.GetTrackByIndex( i ) )
		plsPlayList:ClearSelection()
		plsPlayList:SelectItem( plsPlayList:GetLine(iCurPos+1) )	
		plsPlayList.VBar:SetScroll(iCurPos*17)
	end

end


function WinAmp_Init()
	local bFoundWinAmp = winamp.SetupWinAmp()
	
	if(bFoundWinAmp != true) then // We got problems, no WinAmp Running!
		local wndError = vgui.Create("DFrame")
		wndError:SetTitle("WinAmp Interface: Error!")
		wndError:SetDeleteOnClose(true)
		wndError:SetSize( 430, 120 )
		wndError:Center()
		
		local lblError = vgui.Create( "DLabel", wndError )
		lblError:SetPos( 15, 15 )
		lblError:SetMultiline(true)
		lblError:SetText("WinAmp is not running. This plugin REQUIRES WinAmp to be running while in use.\nYou can click \"Launch WinAmp\" to load WinAmp (this causes GMOD to minimize)\nOr press Ok to continue playing Garry's Mod")
		lblError:SetSize( 400, 75 )
		lblError:SetContentAlignment(5)
		
		local btnOk = vgui.Create( "DButton", wndError )
		btnOk:SetSize( 90, 24 )
		btnOk:SetPos( 105, 85 )
		btnOk:SetText("Ok")
		btnOk:SetContentAlignment(5)
		btnOk.DoClick = function() wndError:Close() end
		
		local btnWinAmp = vgui.Create( "DButton", wndError )
		btnWinAmp:SetSize( 90, 24 )
		btnWinAmp:SetPos( 205, 85 )
		btnWinAmp:SetText("Launch WinAmp")
		btnWinAmp:SetContentAlignment(5)
		btnWinAmp.DoClick = function()
		local bStartSuccess = winamp.StartWinAmp()
		if(bStartSuccess == true) then
			wndError:Close()
		else
			lblError:SetText("You may not have WinAmp Installed (Get it at Winamp.com)\nIf you do have WinAmp installed you will have to start it manually")
			btnWinAmp:Remove()
			btnOk:SetPos( 170, 85 )
		end
		end
		wndError:MakePopup()
		return
	end
	
	if(wndPlayer != nil) then 
		if(wndPlayer:IsVisible()) then return end
	end
	winamp.SetupWinAmp()
	// Build the dialog
	wndPlayer = vgui.Create("DFrame")
	wndPlayer:SetTitle("WinAmp Interface")
	wndPlayer:SetDeleteOnClose( true )
	wndPlayer:SetSize( 480, 385 )
	
	// This is the backdrop (its actually an unused list panel), sort of a waste but its just for asthetics
	local lstSongInfo = vgui.Create( "DPanelList", wndPlayer )
	lstSongInfo:SetPos( 10, 28 )
	lstSongInfo:SetSize( 460, 52 )
	
	// This is the label that contains the current song
	lblCurrentSong = vgui.Create("DLabel", wndPlayer)
	lblCurrentSong:SetPos( 15, 28 )
	lblCurrentSong:SetSize( 375, 24 )
	lblCurrentSong:SetText( "AMP.CURSONG" )
	
	// Time label, contains the current time in the track and the time left
	lblTime = vgui.Create( "DLabel", wndPlayer )
	lblTime:SetPos( 400, 28 )
	lblTime:SetSize( 65, 24 )
	lblTime:SetText( "AMP.TIME" )
	lblTime:SetContentAlignment( 6 )
	
	// Divider
	local divTop = vgui.Create( "Divider", wndPlayer )
	divTop:SetPos( 15, 52 )
	divTop:SetSize( 449, 2 )

	chkRepeat = vgui.Create( "DCheckBoxLabel", wndPlayer )
	chkRepeat:SetPos( 15, 59 )
	chkRepeat:SetText( "Repeat" )
	chkRepeat:SetValue( winamp.GetRepeatMode() )
	chkRepeat:SetConVar("winamp_repeat")
	chkRepeat:SetEnabled(false)
	

	chkShuffle = vgui.Create( "DCheckBoxLabel", wndPlayer )
	chkShuffle:SetPos( 85, 59 )
	chkShuffle:SetText( "Shuffle" )
	chkShuffle:SetValue( winamp.GetShuffleMode() )
	chkShuffle:SetConVar("winamp_shuffle")
	chkShuffle:SetEnabled(false)

	
	// Sample rate and bitrate
	lblSampleRate = vgui.Create( "DLabel", wndPlayer )
	lblSampleRate:SetPos( 368, 54 )
	lblSampleRate:SetSize( 95, 24 )
	lblSampleRate:SetText( "AMP.SAMPLERATE" )
	lblSampleRate:SetContentAlignment( 6 )
	
	lblChannels = vgui.Create( "DLabel", wndPlayer )
	lblChannels:SetPos( 290, 54 )
	lblChannels:SetSize( 80, 24 )
	lblChannels:SetText( "AMP.CHANNELS" )
	lblChannels:SetContentAlignment( 5 )
	
	// Add the seek bar
	sldSeek = vgui.Create( "Slider", wndPlayer )
	sldSeek:SetPos( 10, 84 )
	sldSeek:SetSize( 460, 18 )
	sldSeek:PostMessage( "SetInteger", "b", "1" )
	sldSeek:PostMessage( "SetLower", "f", "0" )
	sldSeek:SetActionFunction( afSeek )
	
	local btnPrev = vgui.Create( "DButton", wndPlayer )
	btnPrev:SetPos( 10, 105 )
	btnPrev:SetSize( 85, 24 )
	btnPrev:SetText( "<< Previous" )
	btnPrev:SetContentAlignment( 5 )
	btnPrev.DoClick = function() winamp.Previous() end
	
	local btnNext = vgui.Create( "DButton", wndPlayer )
	btnNext:SetPos( 386, 105 )
	btnNext:SetSize( 85, 24 )
	btnNext:SetContentAlignment( 5 )
	btnNext:SetText( "Next >>" )
	btnNext.DoClick = function() winamp.Next() end
	
	local btnPlay = vgui.Create( "DButton", wndPlayer )
	btnPlay:SetPos( 104, 105 )
	btnPlay:SetSize( 85, 24 )
	btnPlay:SetContentAlignment( 5 )
	btnPlay:SetText( "Play" )
	btnPlay.DoClick = function() winamp.Play() end
	
	local btnPause = vgui.Create( "DButton", wndPlayer )
	btnPause:SetPos( 198, 105 )
	btnPause:SetSize( 85, 24 )
	btnPause:SetContentAlignment( 5 )
	btnPause:SetText( "Pause" )
	btnPause.DoClick = function() winamp.Pause() end
	
	local btnStop = vgui.Create( "DButton", wndPlayer )
	btnStop:SetPos( 292, 105 )
	btnStop:SetSize( 85, 24 )
	btnStop:SetContentAlignment( 5 )
	btnStop:SetText( "Stop" )
	btnStop.DoClick = function() winamp.Stop() end
	
	local divBottom = vgui.Create( "Divider", wndPlayer )
	divBottom:SetPos( 10, 134 )
	divBottom:SetSize( 460, 2 )
	
	
	// Volume
	lblVolume = vgui.Create( "DLabel", wndPlayer )
	lblVolume:SetPos( 10, 140 )
	lblVolume:SetSize( 78, 24 )
	lblVolume:SetText( "Volume: UNKN" )

	sldVolume = vgui.Create( "Slider", wndPlayer )
	sldVolume:SetPos( 90, 145 )
	sldVolume:SetSize( 100, 15 )
	sldVolume:PostMessage( "SetInteger", "b", "1" )
	sldVolume:PostMessage( "SetLower", "f", "0" )
	sldVolume:PostMessage( "SetHigher", "f", "255" )
	sldVolume:SetActionFunction( afVolume )

	
	local btnOptions = vgui.Create( "DButton", wndPlayer )
	btnOptions:SetPos( 292, 140 )
	btnOptions:SetSize( 85, 24 )
	btnOptions:SetContentAlignment( 5 )
	btnOptions:SetText( "Options" )
	btnOptions.DoClick = function()
		wndPlayer:Close()		
		WinAmp_OptionsDialog()
	end
	
	local btnEqualizer = vgui.Create( "DButton", wndPlayer )
	btnEqualizer:SetPos( 198, 140 )
	btnEqualizer:SetSize( 85, 24 )
	btnEqualizer:SetContentAlignment( 5 )
	btnEqualizer:SetText( "Equalizer" )
	btnEqualizer.DoClick = function()
		wndPlayer:Close()
		WinAmp_EqualizerDialog()
	end
	
	local btnAnnounce = vgui.Create( "DButton", wndPlayer )
	btnAnnounce:SetPos( 386, 140 )
	btnAnnounce:SetSize( 85, 24 )
	btnAnnounce:SetContentAlignment( 5 )
	btnAnnounce:SetText( "Announce" )
	btnAnnounce.DoClick = function()
		RunConsoleCommand( "say", "WinAmp: " ..lblCurrentSong:GetValue() )
	end
	
	// This is awesome garry, thanks!
	
	plsPlayList = vgui.Create( "DListView", wndPlayer )
	plsPlayList:SetMultiSelect( false )
	local colID = plsPlayList:AddColumn( "ID" )
	colID:SetMaxWidth( 40 )
	
	local colSong = plsPlayList:AddColumn( "Song" )

	plsPlayList:SetPos( 10, 170 )
	plsPlayList:SetSize( 460, 203 )
	
	plsPlayList.DoDoubleClick = function()
		// Play the selected song
		winamp.Stop()
		winamp.SetPlaylistPos( plsPlayList:GetSortedID( plsPlayList:GetSelectedLine() )-1 )
		winamp.Play()
	end
	
	WinAmp_UpdatePlaylist()
	
	// This is just to update it right away
	WinAmp_UpdateDialog()

	wndPlayer:MakePopup()
	wndPlayer:Center()
	if( !bDidInit ) then wa_LoadSettings() end
	bDidInit = true
	timer.Create( "winampUpdate", 0.2, 0, WinAmp_UpdateDialog )
end
concommand.Add( "winamp", WinAmp_Init )
