//////////////////////////////////////////////////
// Is the mouse inside a control? (returns t/f)
//////////////////////////////////////////////////
function MouseIsInBounds( panel, slack )

	local imX, imY = gui.MousePos()
	local ipX, ipY = panel:GetPos()
	local ipW, ipH = panel:GetSize()
	local ippX, ippY = panel:GetParent():GetPos()
	ipX = ipX + ippX - slack
	ipY = ipY + ippY - slack
	
	if( ( imX > ipX && imX < ipX + ipW + ( slack * 2 ) ) && ( imY > ipY && imY < ipY + ipH + ( slack * 2 ) ) ) then
		if(winamp.IsMouse1Down()) then // decrease overhead, you don't want to call this all the time because of the gay way that GetAsyncKeyState works.
			return true
		else
			return false
		end
	else
		return false
	end
	
end

//////////////////////////////////////////////////
function wa_SaveSettings()
	// Just grab our CVARs and save them to disk for later use
	local waSettings = {}
	waSettings.HUDMode = cvDrawHUD:GetString()
	waSettings.CustomHUDX = cvHUDX:GetInt()
	waSettings.CustomHUDY = cvHUDY:GetInt()
	waSettings.HUDTransparency = cvHUDTrans:GetInt()
	file.Write( "winamp_interface_settings.txt", util.TableToKeyValues( waSettings ) )
end

function wa_LoadSettings()
	local waSettings = {}
	if( file.Exists( "winamp_interface_settings.txt" ) ) then
		local saved_data = file.Read( "winamp_interface_settings.txt" )
		waSettings = util.KeyValuesToTable( saved_data )
	else
		waSettings.HUDMode = "Top Center"
		waSettings.HUDTransparency = 90
		waSettings.CustomHUDX = 10
		waSettings.CustomHUDY = 10
	end
	RunConsoleCommand("winamp_drawhud", waSettings.HUDMode)
	RunConsoleCommand("winamp_hud_transparency", waSettings.HUDTransparency)
	RunConsoleCommand("winamp_hud_x", waSettings.CustomHUDX)
	RunConsoleCommand("winamp_hud_y", waSettings.CustomHUDY)
end
